#JES- Jython Environment for Students
#Copyright (C) 2004 Aron Giles, Ryan Connelly, Adam Poncz, Patrick Carnahan

import java.lang.System as System
import java.util.Date as Date
import java.lang.StringBuffer as StringBuffer

class JESLogBuffer:

    def __init__(self, program):
	self.CurrentBuffer=StringBuffer();
        self.CurrentBuffer.append("<File Created> <");
        self.CurrentBuffer.append((Date(System.currentTimeMillis())).toString());
        self.CurrentBuffer.append(">\n");

    def resetBuffer(self):
        self.CurrentBuffer=StringBuffer();
        self.CurrentBuffer.append("<File Created> <");
        self.CurrentBuffer.append((Date(System.currentTimeMillis())).toString());
        self.CurrentBuffer.append(">\n");

    def addCommand(self, newString):
        self.CurrentBuffer.append("<Command Run> <");
        self.CurrentBuffer.append((Date(System.currentTimeMillis())).toString());
        self.CurrentBuffer.append("> <");
        self.CurrentBuffer.append(newString);
	self.CurrentBuffer.setCharAt(self.CurrentBuffer.length()-1, '>');
        self.CurrentBuffer.append("\n");

    def addMenuOption(self, newString):
        self.CurrentBuffer.append("<Menu Button Pushed> <");
        self.CurrentBuffer.append((Date(System.currentTimeMillis())).toString());
        self.CurrentBuffer.append("> <");
        self.CurrentBuffer.append(newString);
        self.CurrentBuffer.append(">\n");
        
    def openLogFile(self, fileName):
	self.CurrentBuffer= StringBuffer();
	try:
	    file=open(fileName+"log", "rt");
	    self.CurrentBuffer.append(file.read());
	    self.CurrentBuffer.append("<File Opened> <");
	    self.CurrentBuffer.append(fileName);
	    self.CurrentBuffer.append("> <");
	    self.CurrentBuffer.append((Date(System.currentTimeMillis())).toString());
	    self.CurrentBuffer.append(">\n");
	except:
	    self.resetBuffer();
	    self.CurrentBuffer.append("<Could not find "+fileName+ "log,");
	    self.CurrentBuffer.append(" creating a new logfile>\n");

    def saveLogFile(self, fileName):
	logfile=open(fileName+"log", "wt");
	self.CurrentBuffer.append("<File Saved> <");
	self.CurrentBuffer.append(fileName);
	self.CurrentBuffer.append("> <");
	self.CurrentBuffer.append((Date(System.currentTimeMillis())).toString());
	self.CurrentBuffer.append(">\n");
	logfile.write(self.CurrentBuffer.toString());
	logfile.close();

    def dumpLogToTerm(self):
        System.out.println(self.CurrentBuffer.toString());
        

